Module Module1

    Class DetalleLibro

        Public Ttulo As String
        Public Editorial As String
        Public Autor As String
        Public Precio As Double
        Public NmeroCaptulos As Integer
        Public Copyright As String

        Public Sub New(ByVal Ttulo As String, ByVal Precio As Double)
            Me.Ttulo = Ttulo
            Me.Precio = Precio
            Me.Autor = ""
            Me.NmeroCaptulos = 0
            Me.Editorial = ""
            Me.Copyright = ""
        End Sub

        Public Sub New(ByVal Ttulo As String, ByVal Autor As String, _
           ByVal Editorial As String, ByVal Precio As Double)
            Me.Ttulo = Ttulo
            Me.Precio = Precio
            Me.Autor = Autor
            Me.NmeroCaptulos = 0
            Me.Editorial = Editorial
            Me.Copyright = ""
        End Sub

        Public Sub New(ByVal Ttulo As String, ByVal Autor As String, _
           ByVal Editorial As String, ByVal Precio As Double, _
           ByVal NmeroCaptulos As Integer, ByVal Copyright As Date)
            Me.Ttulo = Ttulo
            Me.Precio = Precio
            Me.Autor = Autor
            Me.NmeroCaptulos = NmeroCaptulos
            Me.Editorial = Editorial
            Me.Copyright = Copyright
        End Sub

        Public Sub MuestraInformacin()
            Console.WriteLine(Ttulo)

            If (Autor.Length > 0) Then
                Console.WriteLine(Autor)
            End If

            If (Editorial.Length > 0) Then
                Console.WriteLine(Editorial)
            End If

            If (Precio > 0.0) Then
                Console.WriteLine(Precio)
            End If

            If (NmeroCaptulos > 0) Then
                Console.WriteLine(NmeroCaptulos)
            End If

            If (Copyright.Length > 0) Then
                Console.WriteLine(Copyright)
            End If
        End Sub
    End Class

    Sub Main()
        Dim Palm = New DetalleLibro("Aplicaciones para Palm OS", 49.99)
        Dim CSharp = New DetalleLibro("Superutilidades para C#", _
          "Wright", "McGraw-Hill/Osborne", 49.99)
        Dim VB = New DetalleLibro("Superutilidades para Visual Basic .NET", _
          "Jamsa", "McGraw-Hill/Osborne", 49.99, 18, "Abril 2002")

        Palm.MuestraInformacin()
        Console.WriteLine()
        VB.MuestraInformacin()
        Console.ReadLine()
    End Sub

End Module

