Module Module1

    Interface Saluda
        Sub BuenosDas()
        Sub BuenasTardes(ByVal FechaActual As DateTime)
    End Interface

    Class Ingls
        Implements Saluda

        Public Sub BuenosDas() Implements Saluda.BuenosDas
            Console.WriteLine("Good morning!")
        End Sub

        Public Sub BuenasTardes(ByVal FechaActual As _
            DateTime) Implements Saluda.BuenasTardes
            Console.WriteLine("Good evening  It is now: " & FechaActual)
        End Sub
    End Class

    Class Espaol
        Implements Saluda

        Public Sub BuenosDas() Implements Saluda.BuenosDas
            Console.WriteLine("Buenos Dias!")
            Console.WriteLine(Now())
        End Sub

        Public Sub BuenasTardes(ByVal FechaActual As DateTime) _
            Implements Saluda.BuenasTardes
            Console.WriteLine("Buenas tardes -- La fecha y hora es: " _
               & FechaActual)
        End Sub
    End Class

    Sub Main()
        Dim Hello As New Ingls()
        Dim Hola As New Espaol()

        Hello.BuenosDas()
        Hello.BuenasTardes(Now())

        Hola.BuenosDas()
        Hola.BuenasTardes(Now())
        Console.ReadLine() ' Pausa para ver la salida por pantalla
    End Sub
End Module

