Imports System.IO

Module Module1

    Public Hoy As DateTime

    Function MismaFecha(ByVal A As DateTime, _
      ByVal B As DateTime) As Boolean

        If (A.Year = B.Year) And (A.DayOfYear = B.DayOfYear) Then
            MismaFecha = True
        Else
            MismaFecha = False
        End If

    End Function

    Sub BuscarEnrbol(ByVal DirectorioBuscarEnrbol As String)
        Dim Archivos As String() = Directory.GetFiles(DirectorioBuscarEnrbol)
        Dim Directorios As String() = Directory.GetDirectories(DirectorioBuscarEnrbol)

        Dim FechaHoraArchivo As DateTime
        Dim NombreArchivo As String
        For Each NombreArchivo In Archivos
            Try
                FechaHoraArchivo = File.GetCreationTime(NombreArchivo)

                If MismaFecha(FechaHoraArchivo, Today) Then
                    Console.WriteLine(NombreArchivo)
                End If
            Catch E As Exception
                Console.WriteLine("Error al acceder a {0}", NombreArchivo)
                Console.WriteLine("Error: {0}", E.Message)
            End Try
        Next

        Dim FechaHoraDirectorio As DateTime
        Dim NombreDirectorio As String
        For Each NombreDirectorio In Directorios
            Try
                FechaHoraDirectorio = _
                Directory.GetCreationTime(NombreDirectorio)

                If MismaFecha(FechaHoraDirectorio, Hoy) Then
                    Console.WriteLine(NombreDirectorio)
                End If

                BuscarEnrbol(NombreDirectorio)
            Catch E As Exception
                Console.WriteLine("Error al acceder a {0}", NombreDirectorio)
                Console.WriteLine("Error: {0}", E.Message)
            End Try
        Next
    End Sub

    Sub Main()
        Hoy = DateTime.Today

        Console.WriteLine("Buscando...")
        BuscarEnrbol("C:\")
        Console.Write("Pulse Intro para continuar...")
        Console.ReadLine()
    End Sub
End Module

