Imports System.IO

Module Module1

    Sub Procesarbol(ByVal DirectorioProcesarbol As String)
        Dim ObjetoDirectorio As New DirectoryInfo(DirectorioProcesarbol)

        Dim Archivos As FileInfo() = ObjetoDirectorio.GetFiles("*.tmp")
        Dim Directorios As DirectoryInfo() = ObjetoDirectorio.GetDirectories("*.*")

        Dim NombreArchivo As FileInfo
        For Each NombreArchivo In Archivos
            Try
                If (NombreArchivo.Attributes And FileAttributes.ReadOnly) Then
                    NombreArchivo.Attributes = _
                     (NombreArchivo.Attributes And Not FileAttributes.ReadOnly)
                End If

                File.Delete(NombreArchivo.FullName)
                Console.WriteLine("Borrado {0}", NombreArchivo.FullName)
            Catch E As Exception
                Console.WriteLine("*** Error al borrar {0}", _
                  NombreArchivo.FullName)
                Console.WriteLine("Error: {0}", E.Message)
            End Try
        Next

        Dim NombreDirectorio As DirectoryInfo
        For Each NombreDirectorio In Directorios
            Try
                Procesarbol(NombreDirectorio.FullName)
            Catch E As Exception
                Console.WriteLine("*** Error al acceder a {0}", _
                   NombreDirectorio.FullName)
                Console.WriteLine("Error: {0}", E.Message)
            End Try
        Next
    End Sub

    Sub Main()
        Procesarbol("C:\")

        Console.Write("Pulse Intro para continuar...")
        Console.ReadLine() ' Pausa para ver la salida
    End Sub
End Module
