Imports System.IO

Module Module1
    Sub MuestraViaAcceso(ByVal P As String)
        Try
            Console.WriteLine("Va de acceso inicial: {0}", P)
            Console.WriteLine("Nombre de directorio: {0}", Path.GetDirectoryName(P))
            Console.WriteLine("Extensin: {0}", Path.GetExtension(P))
            Console.WriteLine("Nombre de archivo: {0}", Path.GetFileName(P))
            Console.WriteLine("Nombre de archivo sin extensin: {0}", _
               Path.GetFileNameWithoutExtension(P))
            Console.WriteLine("Va de acceso completa: {0}", Path.GetFullPath(P))
            Console.WriteLine("Raz: {0}", Path.GetPathRoot(P))
        Catch E As Exception
            Console.WriteLine(" ** Error al procesar **")
            Console.WriteLine("Error: {0}", E.Message)
        End Try
        Console.WriteLine()
    End Sub

    Sub Main()
        MuestraViaAcceso("C:\carpeta\Subdirectorio\archivo.ext")
        MuestraViaAcceso("C:archivo.ext")
        MuestraViaAcceso("C:archivo")
        MuestraViaAcceso("C:\")
        MuestraViaAcceso("\")
        Console.ReadLine() ' Pausa para ver la salida por pantalla
    End Sub
End Module

