Imports System.Threading

Module Module1
    Public Buffer As Integer
    Public BufferVaco As Boolean = True
    Public BloqueoMonitor As Object = New Object()

    Sub Producir()
        Dim Valor As Integer = 0

        Do
            If (Monitor.TryEnter(BloqueoMonitor)) Then
                If (BufferVaco) Then
                    BufferVaco = False
                    Buffer = Valor

                    If (Valor = 0) Then
                        Valor = 1
                    Else
                        Valor = 0
                    End If

                    Console.WriteLine()
                    Console.WriteLine("Productor: " & Buffer)
                End If

                Monitor.Exit(BloqueoMonitor)
            Else
                Console.Write("P")
            End If
        Loop While (True)
    End Sub

    Sub Consumir()
        Dim Valor As Integer

        Do
            If (Monitor.TryEnter(BloqueoMonitor)) Then
                If (Not BufferVaco) Then
                    BufferVaco = True

                    Thread.CurrentThread.Sleep(10)

                    Valor = Buffer
                    Console.WriteLine()
                    Console.WriteLine("Consumidor: " & Valor)
                End If

                Monitor.Exit(BloqueoMonitor)
            Else
                Console.Write("C")
            End If
        Loop While (True)
    End Sub

    Sub Main()
        Dim SubprocesoProductor As Thread
        Dim SubprocesoConsumidor As Thread

        SubprocesoProductor = New Thread(AddressOf Producir)
        SubprocesoConsumidor = New Thread(AddressOf Consumir)

        SubprocesoProductor.Start()
        SubprocesoConsumidor.Start()
    End Sub
End Module

