Imports System.Threading

Module Module1

    Public A As Thread
    Public B As Thread
    Public C As Thread

    Sub Mostrar_A()
        Dim I As Integer
        Try
            A.Suspend()

            For I = 0 To 500
                Console.Write("A")
            Next
        Catch E As ThreadStateException
            Console.WriteLine()
            Console.WriteLine("Excepcin del subproceso A" & E.ToString())
            Console.WriteLine()
        End Try
    End Sub

    Sub Mostrar_B()
        Dim I As Integer
        Try
            For I = 0 To 3000
                Console.Write("B")
            Next
        Catch E As ThreadAbortException
            Console.WriteLine()
            Console.Write("El subproceso B se ha finalizado en la iteracin " & I)
            Console.WriteLine()
        End Try
    End Sub

    Sub Mostrar_C()
        Dim I As Integer
        Try
            If (B.IsAlive) Then
                B.Abort()
            End If

            For I = 0 To 500
                If (A.ThreadState = ThreadState.Suspended) Then
                    A.Resume()
                End If

                Console.Write("C")
            Next
        Catch E As Threading.ThreadStateException
            Console.WriteLine()
            Console.WriteLine("Excepcin del subproceso C" & E.ToString())
            Console.WriteLine()
        End Try
    End Sub

    Sub Main()
        A = New Thread(AddressOf Mostrar_A)
        B = New Thread(AddressOf Mostrar_B)
        C = New Thread(AddressOf Mostrar_C)


        A.Start()
        B.Start()
        C.Start()

        Console.ReadLine()  ' Pausa para ver la salida
    End Sub

End Module

