Module Module1

    Class Accin
        Public Event Sube(ByVal Cantidad As Double)
        Public Event Baja(ByVal Cantidad As Double)
        Public Event Ganancias(ByVal Cantidad As Double, _
          ByVal FechaAnuncio As DateTime)

        Public Sub GenerateEvents()
            RaiseEvent Sube(2)
            RaiseEvent Baja(-5.5)
            RaiseEvent Ganancias(1.25, Now())
        End Sub
    End Class

    Dim WithEvents InformacinAccin As New Accin()

    Sub SubePrecio(ByVal Valor As Double)
        Console.WriteLine("Buenas noticias. El valor de la accin sube: " _
                           & Valor)
    End Sub

    Sub BajaPrecio(ByVal Valor As Double)
        Console.WriteLine("No se preocupe. El valor baja: " & Valor)
    End Sub

    Sub AnuncioGanancias(ByVal Cantidad As Double, _
       ByVal FechaAnuncio As DateTime)
        Console.WriteLine("Anuncio de ganancias: " & Cantidad & _
          " " & FechaAnuncio)
    End Sub

    Sub Main()
        AddHandler InformacinAccin.Sube, AddressOf SubePrecio
        AddHandler InformacinAccin.Baja, AddressOf BajaPrecio
        AddHandler InformacinAccin.Ganancias, AddressOf AnuncioGanancias

        InformacinAccin.GenerateEvents()

        Console.ReadLine()   ' Pausa para ver la salida en pantalla
    End Sub
End Module
