Module Module1

    Class Alarma
        Public Event AlarmaAntirrobo()
        Public Event AlarmaFuego(ByVal Temperatura As Integer)
        Public Event AlarmaMovimiento(ByVal Habitacin As String, _
           ByVal Duracin As Integer)

        Public Sub GenerateEvents()
            RaiseEvent AlarmaAntirrobo()
            RaiseEvent AlarmaFuego(80)
            RaiseEvent AlarmaMovimiento("Comedor", 25)
        End Sub
    End Class

    Dim WithEvents Alarmas As New Alarma()

    Sub AlarmaAntirrobo() Handles Alarmas.AlarmaAntirrobo
        Console.WriteLine("Ha saltado la alarma antirrobo")
    End Sub

    Sub AlarmaFuego(ByVal Temperatura As Integer) Handles Alarmas.AlarmaFuego
        Console.WriteLine("Ha saltado la alarma de incendios: Temperatura: " & Temperatura)
    End Sub

    Sub AlarmaMovimiento(ByVal Habitacin As String, ByVal Duracin As Integer) _
      Handles Alarmas.AlarmaMovimiento
        Console.WriteLine("Ha saltado la alarma de movimiento: " & _
                           Habitacin & " " & Duracin)
    End Sub

    Sub Main()

        Alarmas.GenerateEvents()

        Console.ReadLine()   ' Pausa para ver la salida

    End Sub
End Module

