Module Module1

    Public Class SucesosDiarios
        Public Event Reunin(ByVal Elemento As String, _
           ByVal Hora As String)
        Public Event Comidas(ByVal Elemento As String, _
           ByVal Hora As String)
        Public Event Familia(ByVal Elemento As String, _
           ByVal Hora As String)

        Public Sub GeneraSucesos()
            RaiseEvent Reunin("Presentacin de ventas", "9:30AM")
            RaiseEvent Reunin("Cliente", "11:30AM")
            RaiseEvent Reunin("Produccin", "2:30PM")
            RaiseEvent Comidas("Almuerzo con Juan", "12:30PM")
            RaiseEvent Familia("Partido de Golf", "5:30PM")
        End Sub
    End Class

    Public Class ActividadesHoy
        Inherits SucesosDiarios

        Public DaInicio As DateTime
        Public DaFin As DateTime

        Public Sub New(ByVal DaInicio As DateTime, ByVal DaFin As DateTime)
            MyBase.New()
            Me.DaInicio = DaInicio
            Me.DaFin = DaFin
        End Sub
    End Class

    Dim WithEvents Hoy As New ActividadesHoy(Now(), Now.AddHours(8))

    Sub GestorAgenda(ByVal Elemento As String, _
      ByVal Hora As String)
        Console.WriteLine(Elemento & " a las: " & Hora)
    End Sub

    Sub Main()
        AddHandler Hoy.Reunin, AddressOf GestorAgenda
        AddHandler Hoy.Comidas, AddressOf GestorAgenda
        AddHandler Hoy.Familia, AddressOf GestorAgenda

        Hoy.GeneraSucesos()
        Console.ReadLine()   ' Pausa para ver la salida
    End Sub
End Module
