Module Module1

    Class Libro
        Public Editorial As String
        Public Ttulo As String
        Public Autor As String
        Public Precio As Double

        Public Sub New(ByVal Ttulo As String, ByVal Editorial As String, _
          ByVal Autor As String, ByVal Precio As Double)
            Me.Editorial = Editorial
            Me.Ttulo = Ttulo
            Me.Autor = Autor
            Me.Precio = Precio
        End Sub
    End Class

    Delegate Function Comparar(ByVal A As Libro, _
       ByVal B As Libro) As Boolean

    Dim MtodoComparar As New Comparar(AddressOf CompararAutor)

    Function CompararAutor(ByVal A As Libro, ByVal B As Libro) As Boolean
        If (A.Autor < B.Autor) Then
            CompararAutor = False
        Else
            CompararAutor = True
        End If
    End Function

    Function CompararTtulo(ByVal A As Libro, ByVal B As Libro) As Boolean
        If (A.Ttulo < B.Ttulo) Then
            CompararTtulo = False
        Else
            CompararTtulo = True
        End If
    End Function

    Function CompararPrecio(ByVal A As Libro, ByVal B As Libro) As Boolean
        If (A.Precio < B.Precio) Then
            CompararPrecio = False
        Else
            CompararPrecio = True
        End If
    End Function

    Public Sub Ordenar(ByVal ListaLibros() As Libro)
        Dim I, J As Integer
        Dim Temp As Libro

        For I = 0 To ListaLibros.Length - 2
            For J = I + 1 To ListaLibros.Length - 1
                If (MtodoComparar(ListaLibros(I), ListaLibros(J))) Then
                    Temp = ListaLibros(I)
                    ListaLibros(I) = ListaLibros(J)
                    ListaLibros(J) = Temp
                End If
            Next
        Next
    End Sub

    Sub Main()
        Dim ListaLibro(3) As Libro
        ListaLibro(0) = New Libro("Superutilidades para C#", _
         "McGraw-Hill/Osborne", "Wright", 49.99)

        ListaLibro(1) = _
          New Libro("Superutilidades para Visual Basic .NET", _
          "McGraw-Hill/Osborne", "Jamsa", 49.99)

        ListaLibro(2) = New Libro("Superutilidades para HTML y diseo Web", _
          "McGraw-Hill/Osborne", "King", 49.99)

        ListaLibro(3) = _
          New Libro("Superutilidades para PC", _
          "McGraw-Hill/Osborne", "Jamsa", 39.99)

        Ordenar(ListaLibro)
        Console.WriteLine("Por autor")

        Dim EntradaLibro As Libro
        For Each EntradaLibro In ListaLibro
            Console.WriteLine(EntradaLibro.Ttulo & " " & EntradaLibro.Autor & _
               " " & EntradaLibro.Precio)
        Next

        Console.WriteLine()
        Console.WriteLine("Por ttulo")

        MtodoComparar = AddressOf CompararTtulo
        Ordenar(ListaLibro)
        For Each EntradaLibro In ListaLibro
            Console.WriteLine(EntradaLibro.Ttulo & " " & EntradaLibro.Autor & _
              " " & EntradaLibro.Precio)
        Next

        Console.WriteLine()
        Console.WriteLine("Por precio")

        MtodoComparar = AddressOf CompararPrecio
        Ordenar(ListaLibro)
        For Each EntradaLibro In ListaLibro
            Console.WriteLine(EntradaLibro.Ttulo & " " & EntradaLibro.Autor & _
              " " & EntradaLibro.Precio)
        Next

        Console.ReadLine() ' Pausa para ver la salida
    End Sub
End Module

