Imports System.Reflection

Module Module1
    Class Demo
        Public Sub Hola()
            Console.WriteLine("Hola, Mundo!")
        End Sub

        Public Sub MuestraMensaje(ByVal Mensaje As String)
            Console.WriteLine("Mensaje: " & Mensaje)
        End Sub

        Public Function SumaDosEnteros(ByVal A As Integer, _
          ByVal B As Integer) As Integer
            Console.WriteLine("En SumaDosEnteros con " & A & " " & B)
            SumaDosEnteros = A + B
        End Function

        Public Sub MuestraTresDobles(ByVal A As Double, _
          ByVal B As Double, ByVal C As Double)
            Console.WriteLine(A & " " & B & " " & C)
        End Sub
    End Class

    Sub Main()
        Dim Objeto = New Demo()
        Dim IntegerVar As Integer = 1
        Dim DoubleVar As Double = 100.0
        Dim StringVar As String = "Hola"
        Dim Parmetro As ParameterInfo

        Dim ObjMtodo As System.Reflection.MethodInfo

        For Each ObjMtodo In Objeto.GetType.GetMethods()
            Dim Parmetros(ObjMtodo.GetParameters().Length - 1) _
                As Object

            Dim LlamaMtodo As Boolean = True

            Dim I As Integer = 0

            For Each Parmetro In ObjMtodo.GetParameters()
                If Equals(Parmetro.ParameterType, IntegerVar.GetType()) Then
                    Parmetros(I) = IntegerVar
                ElseIf Equals(Parmetro.ParameterType, DoubleVar.GetType()) Then
                    Parmetros(I) = DoubleVar
                ElseIf Equals(Parmetro.ParameterType, StringVar.GetType()) Then
                    Parmetros(I) = StringVar
                Else
                    LlamaMtodo = False
                End If
                I = I + 1
            Next

            If (LlamaMtodo) Then
                If ObjMtodo.GetParameters().Length = 0 Then
                    Console.WriteLine("Llamando a: " & ObjMtodo.Name)
                    Console.WriteLine(ObjMtodo.Invoke(Objeto, Nothing))
                Else
                    Console.WriteLine("Llamando a: " & ObjMtodo.Name)
                    Console.WriteLine(ObjMtodo.Invoke(Objeto, Parmetros))
                End If
            End If

            Console.WriteLine()
        Next

        Console.ReadLine()
    End Sub

End Module

