Module Module1

    Class Base
        Public Function Mensaje() As String
            Mensaje = "Hola, soy la clase base"
        End Function

        Public Overridable Function Mensaje2() As String
            Mensaje2 = "Mensaje 2 de la clase base"
        End Function

        Public Sub MuestraMensajes()
            Console.WriteLine(MyClass.Mensaje())
            Console.WriteLine(MyClass.Mensaje2())
        End Sub

    End Class



    Class Derivada
        Inherits Base

        Public Shadows Function Mensaje() As String
            Mensaje = "Hola, soy la clase derivada"
        End Function

        Public Overrides Function mensaje2() As String
            mensaje2 = "Mensaje 2 de la clase derivada"
        End Function
    End Class

    Sub Main()
        Dim ObjetoBase As New Base()
        Dim ObjetoDerivada As New Derivada()

        Console.WriteLine("Mensaje del objeto base: " & _
          ObjetoBase.Mensaje())
        Console.WriteLine("Mensaje del objeto derivado:" & _
          ObjetoDerivada.Mensaje())

        Dim ObjetoMixto As Base = New Derivada()
        Console.WriteLine("Objeto mixto: " & ObjetoMixto.Mensaje())

        Console.WriteLine()
        Console.WriteLine("Mensaje 2 de la clase base: " & _
          ObjetoBase.Mensaje2())
        Console.WriteLine("Mensaje 2 de la clase derivada:" & _
          ObjetoDerivada.Mensaje2())
        Console.WriteLine("Mensaje 2 del objeto mixto: " & _
          ObjetoMixto.Mensaje2())

        Console.WriteLine()
        Console.WriteLine("Objeto mixto utilizando MyClass")
        ObjetoMixto.MuestraMensajes()

        Console.ReadLine() ' Pausa para ver la salida
    End Sub


End Module

