Module Module1
    Class Personas
        Public Nombre As String
        Public Edad As Integer

        Public Sub New(ByVal Nombre As String, ByVal Edad As Integer)
            Me.Nombre = Nombre
            Me.Edad = Edad
        End Sub
    End Class

    Class Atletas
        Inherits Personas

        Public Deporte As String
        Public Equipo As String

        Public Sub New(ByVal Nombre As String, ByVal Edad As Integer, _
          ByVal Deporte As String, ByVal Equipo As String)
            MyBase.New(Nombre, Edad)
            Me.Equipo = Equipo
            Me.Deporte = Deporte
        End Sub
    End Class

    Class Estrellas
        Inherits Atletas

        Public PuntosPorPartido As Double
        Public Rebotes As Double

        Public Sub New(ByVal Nombre As String, ByVal Edad As Integer, _
          ByVal Deporte As String, ByVal Equipo As String, _
          ByVal PuntosPorPartido As Double, ByVal Rebotes As Double)

            MyBase.New(Nombre, Edad, Deporte, Equipo)
            Me.PuntosPorPartido = PuntosPorPartido
            Me.Rebotes = Rebotes
        End Sub

        Public Sub Muestra()
            Console.WriteLine("Jugador: " & Nombre)
            Console.WriteLine("Edad: " & Edad)
            Console.WriteLine("Deporte: " & Deporte)
            Console.WriteLine("Equipo: " & Equipo)
            Console.WriteLine("Puntos por partido: " & PuntosPorPartido)
            Console.WriteLine("Rebotes: " & Rebotes)
            Console.ReadLine() '  Pausa para ver la salida por pantalla
        End Sub
    End Class

    Sub Main()
        Dim Kobe As New Estrellas("Kobe Bryant", 23, "Baloncesto", _
           "Lakers", 25.5, 6.3)
        Kobe.Muestra()
    End Sub
End Module

