Module Module1

    Class Demo
        Implements IFormattable
        Implements IComparable

        Public Valor As String

        Public Overridable Overloads Function ToString(ByVal _
          Format As String, ByVal Provider As IFormatProvider) _
          As String Implements IFormattable.ToString

            ToString = Valor
        End Function

        Public Overridable Overloads Function CompareTo(ByVal A _
          As Object) As Integer Implements IComparable.CompareTo
            If (Valor = A.Valor) Then
                CompareTo = 0
            ElseIf (Valor > A.Valor) Then
                CompareTo = -1
            Else
                CompareTo = 1
            End If
        End Function

        Public Sub New(ByVal Valor As String)
            Me.Valor = Valor
        End Sub
    End Class

    Class DemoDerivada
        Inherits Demo

        Public Overloads Overrides Function ToString(ByVal _
          Format As String, ByVal Provider As IFormatProvider) _
          As String
            ToString = UCase(Valor)
        End Function

        Public Sub New(ByVal Valor As String)
            MyBase.New(Valor)
        End Sub
    End Class

    Sub Main()
        Dim A As New Demo("Hola qu tal")
        Dim B As New DemoDerivada("Hola")

        Console.WriteLine(A)
        Console.WriteLine(B)
        Console.WriteLine(A.CompareTo(B))

        Console.ReadLine() ' Pausa para ver la salida
    End Sub
End Module
