Imports System.Threading

Module Module1
    Public Buffer As Integer
    Public BufferVaco As Boolean = True
    Public BloqueoProductorConsumidor As Object = New Object()

    Sub Producir()
        Dim Valor As Integer = 0

        Do
            SyncLock BloqueoProductorConsumidor
                If (BufferVaco) Then
                    BufferVaco = False
                    Buffer = Valor

                    If (Valor = 0) Then
                        Valor = 1
                    Else
                        Valor = 0
                    End If

                    Console.WriteLine("Productor: " & Buffer)
                End If
            End SyncLock
        Loop While (True)
    End Sub

    Sub Consumir()
        Dim Valor As Integer

        Do
            SyncLock BloqueoProductorConsumidor
                If (Not BufferVaco) Then
                    BufferVaco = True
                    Thread.CurrentThread.Sleep(1000)
                    Valor = Buffer
                    Console.WriteLine("Consumidor: " & Valor)
                End If
            End SyncLock
        Loop While (True)
    End Sub

    Sub Main()
        Dim SubprocesoProductor As Thread
        Dim SubprocesoConsumidor As Thread

        SubprocesoProductor = New Thread(AddressOf Producir)
        SubprocesoConsumidor = New Thread(AddressOf Consumir)

        SubprocesoProductor.Start()
        SubprocesoConsumidor.Start()
    End Sub
End Module

