Imports System.Threading

Module Module1
    Public A As Thread
    Public B As Thread
    Public C As Thread
    Public D As Thread

    Sub Mostrar()
        D.Join()
    End Sub

    Sub InfoSubproceso()
        Dim List As ProcessThreadCollection
        List = Process.GetCurrentProcess().Threads()

        Dim objThread As ProcessThread

        For Each objThread In List
            Console.Write("Subproceso: {0:D5}", objThread.Id)
            Console.Write(" Inicio: {0}", objThread.StartTime)
            Console.WriteLine(" Tiempo de CPU: {0}", objThread.TotalProcessorTime)
            Console.Write(" Estado: {0}", objThread.ThreadState)
            If (objThread.ThreadState = System.Diagnostics.ThreadState.Wait) Then
                Console.Write(" Esperando a: {0}", objThread.WaitReason())
            End If
            Console.WriteLine(" Direccin: {0}", objThread.StartAddress())
            Console.WriteLine()
        Next
    End Sub

    Sub Main()
        A = New Thread(AddressOf Mostrar)
        B = New Thread(AddressOf Mostrar)
        C = New Thread(AddressOf Mostrar)
        D = New Thread(AddressOf InfoSubproceso)

        A.Name = "A"
        B.Name = "B"
        C.Name = "C"
        D.Name = "D"

        A.Start()
        B.Start()
        C.Start()
        D.Start()

        Console.ReadLine()  ' Pausa para ver la salida
    End Sub
End Module

