Imports System.Reflection
Module Module1

    Sub Main()
        Dim Ensamblado As [Assembly] = _
          [Assembly].GetExecutingAssembly()

        Console.WriteLine("Cdigo base: " & Ensamblado.CodeBase)
        Console.WriteLine("Nombre completo: " & Ensamblado.FullName)
        Console.WriteLine("Punto de entrada: " & _
           Ensamblado.EntryPoint.ToString())
        Console.WriteLine("En la cach global de ensamblados: " & _
           Ensamblado.GlobalAssemblyCache)
        Console.WriteLine("Ubicacin: " & Ensamblado.Location)

        Console.Write("Tipos: ")
        Dim Tipos As Type
        For Each Tipos In Ensamblado.GetTypes()
            Console.Write(Tipos.Name & " ")
        Next

        Console.WriteLine()

        Console.WriteLine("Ensamblados referidos: ")
        Dim EnsambladosReferidos As AssemblyName

        For Each EnsambladosReferidos In Ensamblado.GetReferencedAssemblies()
            Console.WriteLine(EnsambladosReferidos.FullName)
        Next
        Console.ReadLine()
    End Sub
End Module
