Imports System.ServiceProcess
Imports System.IO

Public Class Service1
    Inherits System.ServiceProcess.ServiceBase

#Region " Cdigo generado por el Diseador de componentes "

    Public Sub New()
        MyBase.New()

        ' El Diseador de componentes requiere esta llamada.
        InitializeComponent()

        ' Agregar cualquier inicializacin despus de la llamada a InitializeComponent()

    End Sub

    'UserService reemplaza a Dispose para limpiar la lista de componentes.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    ' El punto de entrada principal para el proceso
    <MTAThread()> _
    Shared Sub Main()
        Dim ServicesToRun() As System.ServiceProcess.ServiceBase

        ' Se puede ejecutar en el mismo proceso ms de un servicio NT. Para agregar
        ' otro servicio a este proceso, cambie la siguiente lnea a fin de
        ' crear otro objeto de servicio. Por ejemplo,
        '
        '   ServicesToRun = New System.ServiceProcess.ServiceBase () {New Service1, New MySecondUserService}
        '
        ServicesToRun = New System.ServiceProcess.ServiceBase () {New Service1}

        System.ServiceProcess.ServiceBase.Run(ServicesToRun)
    End Sub

    'Requerido por el Diseador de componentes
    Private components As System.ComponentModel.IContainer

    'NOTA: el Diseador de componentes requiere el siguiente procedimiento
    'Se puede modificar utilizando el Diseador de componentes. No lo modifique
    ' con el editor de cdigo.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        '
        'Service1
        '
        Me.CanPauseAndContinue = True
        Me.CanShutdown = True
        Me.ServiceName = "DemoServicio"

    End Sub

#End Region

    Private CanalizacinArchivo As StreamWriter

    Protected Overrides Sub OnStart(ByVal args() As String)
        ' Agregar cdigo aqu para iniciar el servicio. Este mtodo debera poner en movimiento
        ' los elementos para que el servicio pueda funcionar.

        Try
            CanalizacinArchivo = New StreamWriter("C:\DemoSucesos.log", True)
            CanalizacinArchivo.WriteLine("Servicio iniciado el " & DateTime.Now)
            CanalizacinArchivo.Flush()
        Catch E As Exception
        End Try

    End Sub

    Protected Overrides Sub OnStop()
        ' Agregar cdigo aqu para realizar cualquier anulacin necesaria para detener el servicio.

        Try
            CanalizacinArchivo.WriteLine("Servicio terminado el " & DateTime.Now)
            CanalizacinArchivo.Close()
        Catch E As Exception
        End Try

    End Sub

    Protected Overrides Sub OnPause()
        Try
            CanalizacinArchivo.WriteLine("Servicio detenido el " & DateTime.Now)
            CanalizacinArchivo.Flush()
        Catch E As Exception
        End Try
    End Sub

    Protected Overrides Sub OnContinue()
        Try
            CanalizacinArchivo.WriteLine("Servicio reiniciado el " & DateTime.Now)
            CanalizacinArchivo.Flush()

        Catch E As Exception
        End Try
    End Sub

    Protected Overrides Sub OnShutdown()
        Try
            CanalizacinArchivo.WriteLine("Servicio apagado el " & DateTime.Now)
            CanalizacinArchivo.Close()
        Catch E As Exception
        End Try
    End Sub

End Class
