Imports System.ServiceProcess
Imports System.Timers
Imports System.IO

Public Class Service1
    Inherits System.ServiceProcess.ServiceBase

#Region " Cdigo generado por el Diseador de componentes "

    Public Sub New()
        MyBase.New()

        ' El Diseador de componentes requiere esta llamada.
        InitializeComponent()

        ' Agregar cualquier inicializacin despus de la llamada a InitializeComponent()

    End Sub

    'UserService reemplaza a Dispose para limpiar la lista de componentes.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    ' El punto de entrada principal para el proceso
    <MTAThread()> _
    Shared Sub Main()
        Dim ServicesToRun() As System.ServiceProcess.ServiceBase

        ' Se puede ejecutar en el mismo proceso ms de un servicio NT. Para agregar
        ' otro servicio a este proceso, cambie la siguiente lnea a fin de
        ' crear otro objeto de servicio. Por ejemplo,
        '
        '   ServicesToRun = New System.ServiceProcess.ServiceBase () {New Service1, New MySecondUserService}
        '
        ServicesToRun = New System.ServiceProcess.ServiceBase () {New Service1}

        System.ServiceProcess.ServiceBase.Run(ServicesToRun)
    End Sub

    'Requerido por el Diseador de componentes
    Private components As System.ComponentModel.IContainer

    'NOTA: el Diseador de componentes requiere el siguiente procedimiento
    'Se puede modificar utilizando el Diseador de componentes. No lo modifique
    ' con el editor de cdigo.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        '
        'Service1
        '
        Me.CanPauseAndContinue = True
        Me.CanShutdown = True
        Me.ServiceName = "ServicioTemporizado"

    End Sub

#End Region

    Private WithEvents Alarma As _
      Timer = New Timer(300000) ' 5 minutos

    Public Sub OnTimedEvent(ByVal source As Object, _
      ByVal e As ElapsedEventArgs) Handles Alarma.Elapsed

        Dim InformacinDirectorio As DirectoryInfo = New DirectoryInfo("C:\")

        Dim Registro As New EventLog("Application")
        Registro.Source = "ServicioTemporizado"
        Registro.WriteEntry("El nmero de archivos en el directorio raz el " & Now() & ": " & _
                 InformacinDirectorio.GetFiles("*.*").Length())
        Registro.Close()
    End Sub

    Protected Overrides Sub OnStart(ByVal args() As String)
        Alarma.Enabled = True
        Try
            Dim Registro As New EventLog("Application")
            Registro.Source = "ServicioTemporizado"
            Registro.WriteEntry("Servicio iniciado el " & DateTime.Now)
            Registro.Close()
        Catch E As Exception
        End Try
    End Sub

    Protected Overrides Sub OnPause()
        Alarma.Enabled = False
        Try
            Dim Registro As New EventLog("Application")
            Registro.Source = "ServicioTemporizado"
            Registro.WriteEntry("Servicio detenido el " & DateTime.Now)
            Registro.Close()
        Catch E As Exception
        End Try
    End Sub

    Protected Overrides Sub OnContinue()
        Alarma.Enabled = True
        Try
            Dim Registro As New EventLog("Application")
            Registro.Source = "ServicioTemporizado"
            Registro.WriteEntry("Servicio reiniciado el " & DateTime.Now)
            Registro.Close()
        Catch E As Exception
        End Try
    End Sub

    Protected Overrides Sub OnShutdown()
        Alarma.Enabled = False
        Try
            Dim Registro As New EventLog("Application")
            Registro.Source = "ServicioTemporizado"
            Registro.WriteEntry("Servicio apagado el " & DateTime.Now)
            Registro.Close()
        Catch E As Exception
        End Try
    End Sub

    Protected Overrides Sub OnStop()
        Alarma.Enabled = False
        Try
            Dim Registro As New EventLog("Application")
            Registro.Source = "ServicioTemporizado"
            Registro.WriteEntry("Servicio terminado el " & DateTime.Now)
            Registro.Close()
        Catch E As Exception
        End Try
    End Sub

End Class
