Imports System.Attribute

Class NombreDesarrollador
    Inherits Attribute

    Public Nombre
    Public Sub New(ByVal Nombre As String)
        MyBase.New()
        Me.Nombre = Nombre
    End Sub
End Class

Class Demo
    Public Mensaje As String

    <NombreDesarrollador("Kris Jamsa")> Sub DemoMensaje()
        Console.WriteLine(Mensaje)
    End Sub

    <NombreDesarrollador("Phil Schmauder")> Sub Saluda()
        Console.WriteLine("Hola, VB")
    End Sub

    Public Sub New(ByVal MensajeP As String)
        Mensaje = MensajeP
    End Sub
End Class

Module Module1
    Sub Main()
        Dim Mtodo As System.Reflection.MethodInfo
        Dim DemoMensaje As New Demo("Hola, Mundo")

        For Each Mtodo In DemoMensaje.GetType.GetMethods()
            Dim Atributo As Attribute
            For Each Atributo In Mtodo.GetCustomAttributes(False)
                Console.WriteLine(Mtodo.Name)
                Console.WriteLine(Atributo)
                Console.WriteLine(CType(Atributo, NombreDesarrollador).Nombre)
                Console.WriteLine()
            Next
        Next
        Console.ReadLine()

    End Sub

End Module

